import json
import glob
import argparse

def main():
  parser = argparse.ArgumentParser(prog='fio-parser.py', description='%(prog)s is used to parse fio output files')
  parser.add_argument('--directory','-d',type=str,help='Specify the directory with fio output files to parse.  If none if provided, ./ is used')
  args = parser.parse_args()
  jsonfiles = glob.glob("{}/*.json".format(args.directory))

  global_max_throughput = 0
  for i in range(len(jsonfiles)):
    jsonfile = jsonfiles[i]
    max_throughput = 0
    parsed = json.load(open(jsonfile))
    jobs = parsed['jobs']
    
    print('node-{}'.format(i+1))
    for job in jobs:                 
      bw_max = job['write']['bw_max']
      print('  job = {}, write (KiB) = {}, IOPS = {}, max throughput = {} KiB/s'.format(job['jobname'], job['write']['io_kbytes'], job['write']['iops'], bw_max))                     
      max_throughput = bw_max if bw_max > max_throughput else max_throughput
      global_max_throughput = bw_max if bw_max > global_max_throughput else global_max_throughput

    print('node-{}, max throughput = {} KiB/s'.format(i + 1, max_throughput))
    print()
    
  print('global max throughput = {} KiB/s'.format(global_max_throughput))

if __name__ == '__main__':
    main()